<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { getPageMetadata } from '../common/meta';
import {
  Hero,
  Pricing,
  Recognition,
  Tabs,
  VideoSpotlight,
} from '@/components/platform/index.vue';
import { NextStepAlt } from '@/components/common/index.vue';
import CategoriesTable from '@/components/common/categories-table.vue';
export default Vue.extend({
  name: 'Platform',
  components: {
    NextStepAlt,
    CategoriesTable,
    Hero,
    Tabs,
    VideoSpotlight,
    Recognition,
    Pricing,
  },
  async asyncData({ $content, i18n }: any) {
    try {
      const locale = i18n.locale === i18n.defaultLocale ? '' : i18n.locale;
      const data = await $content(locale, `platform`).fetch();
      const categoriesObject = await $content('synced/categories').fetch();
      const stageObject = await $content('synced/stages').fetch();
      return { data, locale, categoriesObject, stageObject };
    } catch (e) {
      throw new Error(e);
    }
  },
  data() {
    return {
      table: {
        plan: [],
        create: [],
        verify: [],
        secure: [],
        package: [],
        deploy: [],
        monitor: [],
        govern: [],
      },
      isLoading: true,
    };
  },
  head(): MetaInfo {
    return getPageMetadata(
      (this as any).data,
      this.$route.path,
      this.$nuxtI18nHead({ addSeoAttributes: true }),
    );
  },
  created() {
    this.isLoading = true;
    this.setTableData(this.categoriesObject, this.stageObject);
  },
  mounted() {
    this.isLoading = false;
  },
  methods: {
    setTableData(categoriesObject, stageObject) {
      Object.entries(stageObject.stages).forEach(([stageName, stageValue]) => {
        Object.entries(stageValue.groups).forEach(([_, groupValue]: any) => {
          Object.entries(groupValue.categories).forEach(
            ([_, categoryName]: any) => {
              const category = categoriesObject[categoryName];

              if (
                category &&
                this.table[stageName] &&
                category.maturity &&
                category.marketing !== false
              ) {
                this.table[stageName].push({
                  name: category.name,
                  stage: stageName,
                  feature_page: category.feature_page || null,
                  marketing_page: category.marketing_page || null,
                  documentation: category.documentation || null,
                  direction: category.direction || null,
                  maturity: category.maturity,
                });
              }
            },
          );
        });
      });
    },
  },
});
</script>

<template>
  <div class="platform-page">
    <section class="hero">
      <Hero :data="data.hero" />
    </section>
    <section class="table-section">
      <div v-show="isLoading === false">
        <CategoriesTable :table="table" :has-icons="true" />
        <SlpContainer class="table-footer">
          <SlpTypography tag="p" variant="body3-bold">{{
            data.table.footnote
          }}</SlpTypography>
          <SlpButton
            variant="tertiary"
            :href="data.table.footer_link"
            :data-ga-name="data.table.footer_data_ga_name"
            :data-ga-location="data.table.footer_data_ga_location"
            >{{ data.table.footer_text }}
            <SlpIcon name="chevron-lg-right" variant="product" class="slp-ml-8"
          /></SlpButton>
        </SlpContainer>
      </div>
    </section>
    <Tabs v-if="data.benefits" :data="data.benefits" />
    <VideoSpotlight :data="data.video_spotlight" />
    <Recognition :data="data.recognition" />
    <Pricing :data="data.pricing" />
    <NextStepAlt :current-locale="locale" />
  </div>
</template>

<style lang="scss" scoped>
.platform-page {
  overflow-x: hidden;
}

::-webkit-scrollbar {
  display: none;
}

.table-section {
  padding: 0 0 $spacing-16 0;
  background: $color-surface-700;
  color: $color-text-50;
  position: relative;
  width: 100%;

  &:deep {
    .table {
      border: 1px solid $color-surface-600;
      border-radius: 8px;
      display: flex;
      flex-wrap: nowrap;
    }

    .column:not(:first-of-type) {
      .features {
        border-left: 1px solid $color-surface-600;
      }
    }

    .stage-name {
      font-size: $text-body-2-bold;
      line-height: $line-height-body-2-bold;
      font-weight: $font-weight-bold;
      position: relative;
      padding-top: 28px;
      padding-bottom: $spacing-24;
      display: flex;
      flex-direction: column;
      justify-content: center;
      text-align: center;
    }

    .slp-icon {
      color: $color-surface-50;
      align-self: center;
    }

    .mature,
    .existing,
    .early {
      color: $color-accent-400;
      font-weight: $font-weight-bold;
    }

    .planned {
      color: $color-text-50;
      font-weight: $font-weight-bold;
      &:after {
        content: '*';
        display: inline-block;
        margin-left: -4px;
      }
    }

    .features {
      padding: $spacing-16;
      border-top: 1px solid $color-surface-600;
      height: 400px; // PATCH: CSS should be adjusted so that this is not hardcoded. We cannot depend on this since column content is dynamic.

      @media (max-width: $breakpoint-md) {
        height: 440px; // PATCH: CSS should be adjusted so that this is not hardcoded. We cannot depend on this since column content is dynamic.
      }

      a,
      p {
        font-size: $text-body-3;
        line-height: $line-height-body-3;
        margin-bottom: $spacing-8;
      }

      a:hover {
        text-decoration: underline;
      }
    }

    .table-footer {
      display: flex;
      justify-content: space-between;
      align-items: baseline;

      @media (max-width: $breakpoint-md) {
        flex-direction: column;
        width: 100%;
      }

      .slp-btn-tertiary {
        color: $color-text-50;
      }
    }
  }
}
</style>
